#include <gint/display.h>
#include <gint/keyboard.h>
#include <gint/std/stdlib.h>
#include <gint/clock.h>
#include <math.h>

#include "fonctions.h"

#include "data.c" //données des noms de ville et des positions



/*
Futurs protos de fonctions:

//fonction affichant le menu et renvoyant l'identifiant du choix (à définir dans un struct ?)
int menu(void);

//fonction principale des "niveaux": fait jouer le joueur et renvoie son score.
//arguments: *noms: tableau des noms des villes/?
			 *coordonees: tableau des coordonees des villes/? dans l'ordre de la liste noms
int session(char *noms, int *coordonees)

//fonction de test et d'affichage du cercle de distance à la vraie ville. renvoie le score correspondant à la distance
//arguments: x, y: position du curseur
//			 nom_x, nom_y: position de la ville 
int test(int x, int y, int nom_x, int nom_y)


*/








int menu(void);
int session(struct data donnees);
void session_dev(bopti_image_t *carte);
double distance(int x1, int y1, int x2, int y2);
void animation_reponse(int x, int y, int posx, int posy);


int main(void)
{
	int choix_menu;
	//dessin d'un cercle au centre de l'écran
	//dellipse(198, 112, 20, 20, C_BLACK);

	while(1)
	{
		//boucle principale
		choix_menu = menu();

		if(choix_menu == -1 || choix_menu == 6)
		{
			break;
		}


		switch (choix_menu)
		{
		case 0:
			session(monde);
			break;

		
		case 1:
			session(france);
			break;

		
		case 2:
			session(europe);
			break;

		
		case 3:
			session(canada);
			break;


		case 4:
			session(usa);
			break;


		case 5:
			session(asie);
			break;
		
		default:
			break;
		}
	}
	

	return 1;
}



/*----------------------------------------------------------------------------------------*/
//fonctions

double distance(int x1, int y1, int x2, int y2)
{
	return pow( (x2 - x1)*(x2 - x1) + (y2 - y1)*(y2 - y1) , 0.5);
}



void animation_reponse(int posx_joueur, int posy_joueur, int posx_ville, int posy_ville)
{
	/*Animation éxécutée après validation du joueur sur la position de la ville demandée*/
	//x, y: position joueur
	//posx, posy: position ville

	

	//dessin du cercle
	dcircle(posx_ville, posy_ville, (int)distance(posx_joueur, posy_joueur, posx_ville, posy_ville), C_RGB(0, 232, 179));

	//dessin pointeur ville
	dline(posx_ville, posy_ville, posx_ville+10, posy_ville-40, C_BLACK);
	dcircle_fill(posx_ville+10, posy_ville-40, 6, C_RGB(0, 255, 0), C_BLACK);

	//dessin pointeur joueur
	dline(posx_joueur, posy_joueur, posx_joueur-10, posy_joueur-40, C_BLACK);
	dcircle_fill(posx_joueur-10, posy_joueur-40, 6, C_RGB(255, 0, 0), C_BLACK);
}


int menu(void)
{
	/*
	Si renvoie -1: quitter*/


	extern bopti_image_t img_menu;

	char const cartes[][8] = {"Monde", "France", "Europe", "Canada", "USA", "Asie"};
	int const posx[] = {177, 135, 194, 34, 56, 253};
	int const posy[] = {194, 54, 74, 48, 96, 86};
	int carte=0; //choix de la carte
	int key;
	int i; //variable de fonctionnement

	while (1)
	{
		//affichage du menu et des options ainsi que du curseur
		dclear(C_WHITE);
		dimage(0, 0, &img_menu);

		for(i=0; i<6; i++)
		{
			if(i == carte)
			{
				dtext_opt(posx[i], posy[i], C_BLACK, C_WHITE, DTEXT_LEFT, DTEXT_TOP, cartes[i]);
				//dessin pointeur
				dline(posx[i]-3, posy[i]+5, posx[i]-10-3, posy[i]-40+5, C_BLACK);
				dcircle_fill(posx[i]-10-3, posy[i]-40+5, 6, C_RGB(255, 0, 0), C_BLACK);
			}
			else
			{
				dtext(posx[i], posy[i], C_BLACK, cartes[i]);
			}
			
		}

		dtext(240, 204, C_BLACK, "Disperseur 2023");
		dupdate();


		//attente de pression sur une touche
		key = getkey().key;

		if(key == KEY_MENU || key == KEY_EXE)
		{
			break;
		}

		if(key == KEY_LEFT && carte > 0)
		{
			carte--;
		}
		else if(key == KEY_RIGHT && carte < 5)
		{
			carte++;
		}
	}
	


	if(key == KEY_MENU)
	{
		return -1;
	}
	else
	{
		return carte;
	}
	
	return 1;
}



int session(struct data donnees)
{
	int x=198; //coordonées initiales du curseur au centre
	int y=112;
	int key;
	int speed = 4;
	int tours;
	int score = 0;

	for(tours = 1; tours < 16; tours++)
	{

		//choix aélatoire d'une ville parmis la liste donnée en argument
		int choix_ville = rand() % 40;

		while(1)
		{
			//boucle de déplacement du curseur

			//affichage
			dclear(C_WHITE);
			dimage(0, 0, donnees.carte);
			dhline(y, C_BLACK); //pointeur
			dvline(x, C_BLACK);

			//dessin pointeur joueur
			dline(x, y, x-10, y-40, C_BLACK);
			dcircle_fill(x-10, y-40, 6, C_RGB(255, 0, 0), C_BLACK);

			dprint_opt(1, 1, C_BLACK, C_WHITE, DTEXT_LEFT, DTEXT_TOP, "Score: %d", score);
			dprint_opt(1, 15, C_BLACK, C_WHITE, DTEXT_LEFT, DTEXT_TOP, "Ou est %s ?", donnees.noms[choix_ville]);
			dprint_opt(350, 1, C_BLACK, C_WHITE, DTEXT_LEFT, DTEXT_TOP, "[%d/%d]", tours, 16);
			dupdate();


			

			//commandes clavier

			key = getkey().key;

			if(key == KEY_EXIT || key == KEY_EXE)
			{
				break;
			}
			if(key == KEY_UP && y > 0)
			{
				y = y - speed;
			}
			else if(key == KEY_DOWN && y < 226)
			{
				y = y + speed;
			}
			else if(key == KEY_LEFT && x > 0)
			{
				x = x - speed;
			}
			else if(key == KEY_RIGHT && x < 396)
			{
				x = x + speed;
			}
			else if(key == KEY_5)
			{
				x = 198;
				y = 112;
			}
			else if(key == KEY_ADD)
			{
				speed = 4;
			}
			else if(key == KEY_SUB)
			{
				speed = 1;
			}
			
		}
		
		if(key == KEY_EXIT)
		{
			return -1;
		}
		


		//calcul de la distance à la ville
		double d = distance(x, y, donnees.posx[choix_ville], donnees.posy[choix_ville]);


		dclear(C_WHITE);
		dimage(0, 0, donnees.carte);
		dprint_opt(1, 1, C_BLACK, C_WHITE, DTEXT_LEFT, DTEXT_TOP, "Score: %d", score);
		dprint_opt(350, 1, C_BLACK, C_WHITE, DTEXT_LEFT, DTEXT_TOP, "[%d/%d]", tours, 16);
		
		//affichage du cercle et des pointeurs
		animation_reponse(x, y, donnees.posx[choix_ville], donnees.posy[choix_ville]);



		//gestion des scores
		if(d < 5)
		{
			score += 5;
			dprint_opt(1, 15, C_BLACK, C_WHITE, DTEXT_LEFT, DTEXT_TOP, "Quelle precision !!");
		}
		else if(d < 15)
		{
			score += 2;
			dprint_opt(1, 15, C_BLACK, C_WHITE, DTEXT_LEFT, DTEXT_TOP, "Pas mal !");
		}
		else if(d < 50)
		{
			score += 1;
			dprint_opt(1, 15, C_BLACK, C_WHITE, DTEXT_LEFT, DTEXT_TOP, "Il faudrait etre plus precis...");
		}
		else
		{
			dprint_opt(1, 15, C_BLACK, C_WHITE, DTEXT_LEFT, DTEXT_TOP, "Trop loin de la verite...");
		}


		
		
		dupdate();


		sleep_us(3000000); //sleep 3 s
		
	}

	dclear(C_WHITE);
	dimage(0, 0, donnees.carte);

	drect(80, 80, 396-80, 226-80, C_RGB(71, 255, 255));
	dprint(140, 100, C_BLACK, "Score final: %d", score);


	if(score < 20)
	{
		dprint(135, 115, C_BLACK, "Un petit score...");
	}
	else if(score < 40)
	{
		dprint(110, 115, C_BLACK, "Un geographe en herbe !");
	}
	else
	{
		dprint(140, 115, C_BLACK, "Exceptionnel !");
	}

	dupdate();


	getkey();

	return 1;
}




void session_dev(bopti_image_t *carte)
{
	//affiche une carte, un curseur et les coordonnées du curseur

	int x=198; //coordonées initiales du curseur au centre
	int y=112;
	int key;
	int speed = 1;

	while(1)
	{
		dclear(C_WHITE);
		dimage(0,  0, carte);

		dprint(1, 1, C_BLACK, "(%d, %d) %d", x, y, speed); //Affiche la position du curseur et le mode de vitesse

		dhline(y, C_BLACK);
		dvline(x, C_BLACK);

		dupdate();

		key = getkey().key;

		//commandes clavier
		if(key == KEY_EXIT || key == KEY_EXE)
		{
			break;
		}

		if(key == KEY_UP && y > 0)
		{
			y = y - speed;
		}
		else if(key == KEY_DOWN && y < 226)
		{
			y = y + speed;
		}
		else if(key == KEY_LEFT && x > 0)
		{
			x = x - speed;
		}
		else if(key == KEY_RIGHT && x < 396)
		{
			x = x + speed;
		}
		else if(key == KEY_5)
		{
			x = 198;
			y = 112;
		}
		else if(key == KEY_ADD)
		{
			speed = 4;
		}
		else if(key == KEY_SUB)
		{
			speed = 1;
		}
	}
}
